/* <<< Start of information >>>                                             */
/* This file is part of the xwatch package.                                 */
/* Copyright (C) 1995 Karel Kubat.  All rights reserved.                    */
/*                                                                          */
/* This program is free software; you can redistribute it and/or modify it  */
/* under the terms of the GNU General Public License as published by the    */
/* Free Software Foundation; either version 2 of the License, or (at your   */
/* option) any later version.                                               */
/*                                                                          */
/* You may link this software with XForms (Copyright (C) by T.C. Zhao and   */
/* Mark Overmars) and distribute the resulting binary, under the            */
/* restrictions in clause 3 of the GPL, even though the resulting binary is */
/* not, as a whole, covered by the GPL. (You still need a separate license  */
/* to do so from the owner(s) of the copyright for XForms, however).  If a  */
/* derivative no longer requires XForms, you may use the unsupplemented GPL */
/* as its license by deleting this paragraph and therefore removing this    */
/* exemption for XForms.                                                    */
/*                                                                          */
/* This program is distributed in the hope that it will be useful,          */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            */
/* GNU General Public License for more details.                             */
/*                                                                          */
/* You should have received a copy of the GNU General Public License        */
/* along with this program; if not, write to the Free Software              */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA */
/* <<< End of information >>>                                               */

#include "xwatch.h"

/* convert geometry string to xpos, ypos, width, height */
void parsegeometry (char *str, int *xp, int *yp, int *wp, int *hp)
{
    int
        x,
        y,
        w,
        h,
	nread;
        
    if (! str || ! *str)                    /* no string, no parsing */
        return;
        
    /* try to match NRxNR as first part of the string */
    if (sscanf (str, "%dx%d%n", &w, &h, &nread) > 1)
    {
        *wp = w;
        *hp = h;
        str += nread;
        if (! *str)
            return;
    }
    
    /* now try all forms +NR+NR, -NR-NR, etc.. */
    if (sscanf (str, "+%d+%d", &x, &y) > 1)
    {
        *xp = x; 
        *yp = y;
    }
    else if (sscanf (str, "-%d+%d", &x, &y) > 1)
    {
        *xp = -x;
        *yp = y;
    }
    else if (sscanf (str, "+%d-%d", &x, &y) > 1)
    {
        *xp = x;
        *yp = -y;
    }
    else if (sscanf (str, "-%d-%d", &x, &y) > 1)
    {
        *xp = -x;
        *yp = -y;
    }
}
