/* <<< Start of information >>>                                             */
/* This file is part of the xwatch package.                                 */
/* Copyright (C) 1995 Karel Kubat.  All rights reserved.                    */
/*                                                                          */
/* This program is free software; you can redistribute it and/or modify it  */
/* under the terms of the GNU General Public License as published by the    */
/* Free Software Foundation; either version 2 of the License, or (at your   */
/* option) any later version.                                               */
/*                                                                          */
/* You may link this software with XForms (Copyright (C) by T.C. Zhao and   */
/* Mark Overmars) and distribute the resulting binary, under the            */
/* restrictions in clause 3 of the GPL, even though the resulting binary is */
/* not, as a whole, covered by the GPL. (You still need a separate license  */
/* to do so from the owner(s) of the copyright for XForms, however).  If a  */
/* derivative no longer requires XForms, you may use the unsupplemented GPL */
/* as its license by deleting this paragraph and therefore removing this    */
/* exemption for XForms.                                                    */
/*                                                                          */
/* This program is distributed in the hope that it will be useful,          */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            */
/* GNU General Public License for more details.                             */
/*                                                                          */
/* You should have received a copy of the GNU General Public License        */
/* along with this program; if not, write to the Free Software              */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA */
/* <<< End of information >>>                                               */

#include "xwatch.h"

void usage ()
{
    printf
(
 "\n"
 "XWatch - an X Log File Watcher  V" VER "\n"
 "Copyright (C) 1995, 1996 Karel Kubat <karel@icce.rug.nl>.\n"
 "\n"
 "Usage: xwatch [options] file(s)\n"
 "where:\n"
 "  options may be:\n"
 "   XForms options:\n"
 "    -bw width                     - specifies border width\n"
 "    -debug level                  - debugging level\n"
 "    -depth d                      - visual depth\n"
 "    -double                       - turns on double buffering\n"
 "    -display host:display         - the display, default: $DISPLAY\n"
 "    -name applicationname         - application name, default: XWatch\n"
 "    -private, -shared, -stdcmap   - private or shared or standard colormap\n"
 "    -rgamma red, -ggamma green,\n"
 "        -bgamma blue              - gamma for red/green/blue components\n"
 "    -sync                         - forces synchronous mode\n"
 "    -vid id                       - preferred visual ID\n"
 "    -visual class                 - visual class, e.g. TrueColor\n"
 "   Xwatch options: (# stands for a number, [..] means default)\n"
 "    -border 0|1           - start text window with or without border   [1]\n"
 "    -bg R/G/B or -bg col  - states background color, either as three\n"
 "                            red/green/blue numbers or as one name  [white]\n"
 "    -colorstring col:text - uses color for lines having text in them\n"
 "    -firstwarnings 0|1    - print warnings about files upon startup    [1]\n"
 "    -fg R/G/B or -fg col  - states foreground                      [black]\n"
 "    -fontsize #           - size of font: 1=smallest, 4=largest        [2]\n"
 "    -fontstyle #          - used font:\n"
 "                             0=helvetica, 1=+bold, 2=+italic, 3=bold/it\n"
 "                             4=courier,   5=+bold, 6=+italic, 7=bold/it\n"
 "                             8=times,     9=+bold,10=+italic,11=bold/it\n"
 "                            12=charter,  13=+bold,14=+italic,\n"
 "                            15=symbol                                  [0]\n"
 "    -gag text             - don't show lines with text              [none]\n"
 "    -ignore file|file|... - do not add named files to the watchlist\n"
 "    -interval #           - scanning interval in sec, 1 to 30          [5]\n"
 "    -newline 0|1          - print newline after stamp and name         [0]\n"
 "    -nlines #             - nr of lines to store; 10 to 1000         [200]\n"
 "    -printname 0|1        - print filenames                            [1]\n"
 "    -printtime 0|1        - print timestamps                           [1]\n"
 "    -printversion 0|1     - print version/copyright upon startup       [1]\n"
 "    -title name           - use name for window title             [XWatch]\n"
 "    -geometry geom        - display geometry                  [550x70+0+0]\n"
 "   Obsolete options, replace with newer alternatives:\n"
 "    -width, -height, -xpos, -ypos: replace by -geometry\n"
 "    -bred, -bgreen, -bblue: replace by -bg\n"
 "    -fred, -fgreen, -fblue: replace by -fg\n"
 "  file(s): the files to monitor. You can specify an alternate color for\n"
 "  a file using the syntax filename:colorname, in which the colorname\n"
 "  overrules the default foreground color.\n"
 "\n"
 );

    exit (1);
}
